<?php
/**
 * CommentsTag automatically generated by SDKgen please do not edit this file manually
 * @see https://sdkgen.app
 */

namespace SdkFabric\Airtable;

use GuzzleHttp\Exception\BadResponseException;
use Sdkgen\Client\Exception\ClientException;
use Sdkgen\Client\Exception\UnknownStatusCodeException;
use Sdkgen\Client\TagAbstract;

class CommentsTag extends TagAbstract
{
    /**
     * @param string $baseId
     * @param string $tableIdOrName
     * @param string $recordId
     * @return CommentCollection
     * @throws ClientException
     */
    public function getAll(string $baseId, string $tableIdOrName, string $recordId): CommentCollection
    {
        $url = $this->parser->url('/v0/:baseId/:tableIdOrName/:recordId/comments', [
            'baseId' => $baseId,
            'tableIdOrName' => $tableIdOrName,
            'recordId' => $recordId,
        ]);

        $options = [
            'query' => $this->parser->query([
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('GET', $url, $options);
            $data = (string) $response->getBody();

            return $this->parser->parse($data, CommentCollection::class);
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $data = (string) $e->getResponse()->getBody();

            switch ($e->getResponse()->getStatusCode()) {
                default:
                    throw new UnknownStatusCodeException('The server returned an unknown status code');
            }
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * @param string $baseId
     * @param string $tableIdOrName
     * @param string $recordId
     * @param Comment $payload
     * @return Comment
     * @throws ClientException
     */
    public function create(string $baseId, string $tableIdOrName, string $recordId, Comment $payload): Comment
    {
        $url = $this->parser->url('/v0/:baseId/:tableIdOrName/:recordId/comments', [
            'baseId' => $baseId,
            'tableIdOrName' => $tableIdOrName,
            'recordId' => $recordId,
        ]);

        $options = [
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload
        ];

        try {
            $response = $this->httpClient->request('POST', $url, $options);
            $data = (string) $response->getBody();

            return $this->parser->parse($data, Comment::class);
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $data = (string) $e->getResponse()->getBody();

            switch ($e->getResponse()->getStatusCode()) {
                default:
                    throw new UnknownStatusCodeException('The server returned an unknown status code');
            }
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * @param string $baseId
     * @param string $tableIdOrName
     * @param string $recordId
     * @param string $rowCommentId
     * @param Comment $payload
     * @return Comment
     * @throws ClientException
     */
    public function update(string $baseId, string $tableIdOrName, string $recordId, string $rowCommentId, Comment $payload): Comment
    {
        $url = $this->parser->url('/v0/:baseId/:tableIdOrName/:recordId/comments/:rowCommentId', [
            'baseId' => $baseId,
            'tableIdOrName' => $tableIdOrName,
            'recordId' => $recordId,
            'rowCommentId' => $rowCommentId,
        ]);

        $options = [
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload
        ];

        try {
            $response = $this->httpClient->request('PATCH', $url, $options);
            $data = (string) $response->getBody();

            return $this->parser->parse($data, Comment::class);
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $data = (string) $e->getResponse()->getBody();

            switch ($e->getResponse()->getStatusCode()) {
                default:
                    throw new UnknownStatusCodeException('The server returned an unknown status code');
            }
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * @param string $baseId
     * @param string $tableIdOrName
     * @param string $recordId
     * @param string $rowCommentId
     * @return CommentDeleteResponse
     * @throws ClientException
     */
    public function delete(string $baseId, string $tableIdOrName, string $recordId, string $rowCommentId): CommentDeleteResponse
    {
        $url = $this->parser->url('/v0/:baseId/:tableIdOrName/:recordId/comments/:rowCommentId', [
            'baseId' => $baseId,
            'tableIdOrName' => $tableIdOrName,
            'recordId' => $recordId,
            'rowCommentId' => $rowCommentId,
        ]);

        $options = [
            'query' => $this->parser->query([
            ], [
            ]),
        ];

        try {
            $response = $this->httpClient->request('DELETE', $url, $options);
            $data = (string) $response->getBody();

            return $this->parser->parse($data, CommentDeleteResponse::class);
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $data = (string) $e->getResponse()->getBody();

            switch ($e->getResponse()->getStatusCode()) {
                default:
                    throw new UnknownStatusCodeException('The server returned an unknown status code');
            }
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }


}
