<?php
/**
 * FieldsTag automatically generated by SDKgen please do not edit this file manually
 * @see https://sdkgen.app
 */

namespace SdkFabric\Airtable;

use GuzzleHttp\Exception\BadResponseException;
use Sdkgen\Client\Exception\ClientException;
use Sdkgen\Client\Exception\UnknownStatusCodeException;
use Sdkgen\Client\TagAbstract;

class FieldsTag extends TagAbstract
{
    /**
     * @param string $baseId
     * @param string $tableId
     * @param Field $payload
     * @return Field
     * @throws ClientException
     */
    public function create(string $baseId, string $tableId, Field $payload): Field
    {
        $url = $this->parser->url('/v0/meta/bases/:baseId/tables/:tableId/fields', [
            'baseId' => $baseId,
            'tableId' => $tableId,
        ]);

        $options = [
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload
        ];

        try {
            $response = $this->httpClient->request('POST', $url, $options);
            $data = (string) $response->getBody();

            return $this->parser->parse($data, Field::class);
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $data = (string) $e->getResponse()->getBody();

            switch ($e->getResponse()->getStatusCode()) {
                default:
                    throw new UnknownStatusCodeException('The server returned an unknown status code');
            }
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }

    /**
     * @param string $baseId
     * @param string $tableId
     * @param string $columnId
     * @param Field $payload
     * @return Field
     * @throws ClientException
     */
    public function update(string $baseId, string $tableId, string $columnId, Field $payload): Field
    {
        $url = $this->parser->url('/v0/meta/bases/:baseId/tables/:tableId/fields/:columnId', [
            'baseId' => $baseId,
            'tableId' => $tableId,
            'columnId' => $columnId,
        ]);

        $options = [
            'query' => $this->parser->query([
            ], [
            ]),
            'json' => $payload
        ];

        try {
            $response = $this->httpClient->request('PATCH', $url, $options);
            $data = (string) $response->getBody();

            return $this->parser->parse($data, Field::class);
        } catch (ClientException $e) {
            throw $e;
        } catch (BadResponseException $e) {
            $data = (string) $e->getResponse()->getBody();

            switch ($e->getResponse()->getStatusCode()) {
                default:
                    throw new UnknownStatusCodeException('The server returned an unknown status code');
            }
        } catch (\Throwable $e) {
            throw new ClientException('An unknown error occurred: ' . $e->getMessage());
        }
    }


}
